package net.cijber.pubgrub.version

import net.cijber.pubgrub.stubs.Version

interface VersionConstraint<V : Version<V>> {
    fun allows(version: V): Boolean
    fun allowsAll(rhs: VersionConstraint<V>): Boolean
    fun allowsAny(rhs: VersionConstraint<V>): Boolean
    fun intersect(rhs: VersionConstraint<V>): VersionConstraint<V>
    fun difference(rhs: VersionConstraint<V>): VersionConstraint<V>
    fun union(rhs: VersionConstraint<V>): VersionConstraint<V>
    val isAny: Boolean
    val isEmpty: Boolean
}